/*
 * This code is demonstration code created by Mitchel Sellers                   
 * (mitchel.sellers@gmail.com).  It is provided as a training tool only and does
 * not come with a guarantee expressed nor implied.  You may freely utilize     
 * portions of the code provided here, however if this code is passed on in this
 * exact form this notice should be left at the top of all code files.
 * 
 * If you have any questions regarding this code please feel free to contact me 
 * at the email address listed above
 *
 */

using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;   //Reference required to be granted access to regular expressions

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            //Prompt the user, 2 separate input items (inputRegEx and inputMatchText)
            Console.WriteLine("Welcome to the Regular Expression demonstrator!");
            Console.Write("Please enter a regular expression string:");
            string inputRegEx = Console.ReadLine();
            Console.Write("Please enter a test string for matching:");
            string inputMatchText = Console.ReadLine();

            //Perform the match test, then output the result
            bool isDirectMatch = Regex.IsMatch(inputMatchText, inputRegEx);
            Console.WriteLine("Result of Regex.IsMatch(string input, string expression): " + isDirectMatch.ToString());

            //Perform the match test, using the ignore case option
            bool isIgnoreCaseMatch = Regex.IsMatch(inputMatchText, inputRegEx, RegexOptions.IgnoreCase);
            Console.WriteLine("Result of RegEx.IsMatch(string input, string expression, RegexOptions options): "
                                + isIgnoreCaseMatch);

            //Perform Matches() test
            MatchCollection oMatches = Regex.Matches(inputMatchText, inputRegEx);
            Console.WriteLine("Matches found using Regex.Matches(string input, string pattern): " 
                                + oMatches.Count.ToString());

            Console.WriteLine("Match Detail, if appliciable");

            //Loop through the collection, this will be skipped if no match
            foreach (Match oMatch in oMatches)
            {
                Console.WriteLine("Match Index: " + oMatch.Index.ToString());
                Console.WriteLine("Match Length: " + oMatch.Length.ToString());
                Console.WriteLine("Match Value: " + oMatch.Value);
                Console.WriteLine("");

            }

            //Keep screen active
            Console.Read();
        }
    }
}
